Page MenuHomeVyOS Platform

WAN load-balancing fails with nexthop dhcp
Closed, ResolvedPublicBUG

Description

To reproduce:

configure
set interfaces dummy dum0
set interfaces ethernet eth0 address dhcp
set load-balancing wan interface-health eth0 nexthop dhcp
set load-balancing wan rule 1 inbound-interface dum0
set load-balancing wan rule 1 interface eth0
commit
exit
show wan-load-balance

Details

Difficulty level
Easy (less than an hour)
Version
1.3-beta-202103080443
Why the issue appeared?
Implementation mistake
Is it a breaking change?
Perfectly compatible

Event Timeline

Looks good on 1.4-rolling-202103090218:

vyos@vyos:~$ configure
[edit]
vyos@vyos# set interfaces dummy dum0
[edit]
vyos@vyos# set interfaces ethernet eth0 address dhcp
[edit]
vyos@vyos# set load-balancing wan interface-health eth0 nexthop dhcp
[edit]
vyos@vyos# set load-balancing wan rule 1 inbound-interface dum0
[edit]
vyos@vyos# set load-balancing wan rule 1 interface eth0
[edit]
vyos@vyos# commit
[edit]
vyos@vyos# exit
Warning: configuration changes have not been saved.
exit
vyos@vyos:~$ show wan-load-balance
Interface:  eth0
  Status:  active
  Last Status Change:  Tue Mar  9 14:41:08 2021
  +Test:  ping  Target: 192.168.251.1
    Last Interface Success:  0s 
    Last Interface Failure:  11s        
    # Interface Failure(s):  0

vyos@vyos:~$ show version

Version:          VyOS 1.4-rolling-202103090218
Release Train:    sagitta

Built by:         autobuild@vyos.net
Built on:         Tue 09 Mar 2021 02:18 UTC
Build UUID:       d53c043f-afcf-41bb-95f3-b4721d41e88e
Build Commit ID:  e758a269e84509

Architecture:     x86_64
Boot via:         installed image
System type:      KVM guest

Hardware vendor:  QEMU
Hardware model:   Standard PC (Q35 + ICH9, 2009)
Hardware S/N:     
Hardware UUID:    e95a0ef9-332d-409b-90df-0b895e12893b

Copyright:        VyOS maintainers and contributors
stepler changed the task status from In progress to Backport candidate.Mar 9 2021, 2:42 PM
Viacheslav added a subscriber: Viacheslav.

The same bug with 1.2.7-epa1

set interfaces dummy dum0
set interfaces ethernet eth1 address dhcp
set load-balancing wan interface-health eth1 nexthop dhcp
set load-balancing wan rule 1 inbound-interface dum0
set load-balancing wan rule 1 interface eth1
commit

Status

vyos@r2-1.2.7-epa1:~$ show wan-load-balance 
Interface:  eth1
  Status:  active
  Last Status Change:  Thu Mar 11 09:31:54 2021
  +Test:  ping  Target: 
    Last Interface Success:  0s 
    Last Interface Failure:  2m35s      
    # Interface Failure(s):  0

It should be another solution?

vyos@r2-1.2.7-epa1:~$ cat /var/lib/dhcp/dhclient_eth1_lease
Thu Mar 11 09:28:58 UTC 2021
reason='BOUND'
interface='eth1'
new_expiry='1615458537'
new_dhcp_lease_time='3600'
medium=''
alias_ip_address=''
new_ip_address='192.168.101.133'
new_broadcast_address='192.168.101.255'
new_subnet_mask='255.255.255.0'
new_domain_name='wan2'
new_network_number='192.168.101.0'
new_domain_name_servers='192.168.101.1'
new_routers='192.168.101.1'
new_static_routes=''
new_dhcp_server_identifier='192.168.101.1'
new_dhcp_message_type='5'
old_ip_address=''
old_subnet_mask=''
old_domain_name=''
old_domain_name_servers=''
old_routers=''
old_static_routes=''
vyos@r2-1.2.7-epa1:~$
stepler reopened this task as Backport candidate.Mar 11 2021, 7:44 PM
dmbaturin changed Why the issue appeared? from Will be filled on close to Implementation mistake.
stepler reopened this task as Backport candidate.Mar 15 2021, 4:14 PM

Waiting on backport to 1.3.

stepler reopened this task as Backport pending.Mar 22 2021, 1:56 PM
stepler added a subscriber: c-po.

@c-po, you cherry-picked the wrong commit: equuleus needs the fix from current, not crux.

Looks good on 1.3-rolling-202104220921:

vyos@vyos:~$ configure
[edit]
vyos@vyos# set interfaces dummy dum0
[edit]
vyos@vyos# set interfaces ethernet eth0 address dhcp
[edit]
vyos@vyos# set load-balancing wan interface-health eth0 nexthop dhcp
[edit]
vyos@vyos# set load-balancing wan rule 1 inbound-interface dum0
[edit]
vyos@vyos# set load-balancing wan rule 1 interface eth0
[edit]
vyos@vyos# commit
[edit]
vyos@vyos# exit
Warning: configuration changes have not been saved.
exit
vyos@vyos:~$ show wan-load-balance
Interface:  eth0
  Status:  active
  Last Status Change:  Fri Apr 23 18:46:54 2021
  +Test:  ping  Target: 192.168.251.1
    Last Interface Success:  0s 
    Last Interface Failure:  10s        
    # Interface Failure(s):  0

vyos@vyos:~$ show version

Version:          VyOS 1.3-rolling-202104220921
Release Train:    equuleus

Built by:         autobuild@vyos.net
Built on:         Fri 23 Apr 2021 03:42 UTC
Build UUID:       f06f0807-961f-404b-a2c0-f0c4209c4079
Build Commit ID:  470b2d00790a82

Architecture:     x86_64
Boot via:         installed image
System type:      KVM guest

Hardware vendor:  QEMU
Hardware model:   Standard PC (Q35 + ICH9, 2009)
Hardware S/N:     
Hardware UUID:    168cdcd5-eb03-47a4-b333-30abc4f0b84f

Copyright:        VyOS maintainers and contributors